int motor_1_in_1 = 2; //INPUT 1
int motor_1_in_2 = 4; //INPUT 2
int motor_1_enable = 9; //ENABLE A


boolean dir = false;
int speed1=0;
int direction1=2;
int main1;
int brake1=0;
char* direction_name[] ={ "clockwise" , "counter-clockwise" , "null"};

int j0=1;
int j1=0;
int j2=0;
int j3=0;
int j4=0;
int j5=0;
int j6=0;

int k0=1;
int k1=0;
int k2=1;
int k3=0;
int k4=0;
int k5=0;
int k6=0;



void setup(){ 

  pinMode(motor_1_in_1, OUTPUT);
  pinMode(motor_1_in_2, OUTPUT);
  pinMode(motor_1_enable, OUTPUT);

  Serial.begin(9600); 
  
} 


void loop(){ 
  
  digitalWrite(A1,HIGH);
  my_menu();
  
}


//FUNCTION FOR THE MAIN MENU
void my_menu(){                                                                          
  if(k0==1){
         Serial.println(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
         Serial.println("MAIN MENU - select option");
         Serial.println("<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<");
         Serial.println("        ");
         Serial.println("............................................................");
         Serial.print("Current Direction="); Serial.println(direction_name[direction1]);
         Serial.print("Current speed="); Serial.println(speed1);
         Serial.println("............................................................");

         Serial.println("Press 1 to Set Direction");
         Serial.println("Press 2 to Set Speed");
         Serial.println("Press 3 to Brake");
         Serial.println("  ");


         
         k1=1;
   }
           
  while (! Serial.available());
         
   if (Serial.available() && k1==1){  
     main1 = Serial.parseInt();
    
     if(main1==1){
       k2=1;  
       my_direction();   //FUNCTION FOR CONTROLLING THE DIRECTION
     }
     
     else if(main1==2){
       k3=1;  
       my_speed();       //FUNCTION FOR CONTROLLING THE SPEED
     }
    
     else if(main1==3){
       k4=1;  
       brake();          //FUNCTION FOR THE BRAKING OF THE MOTOR
     }
    
     else{
       Serial.println("Invalid entry");
       k1=0;
       my_menu();  
     }   
 
   } 
 }


//FUNCTION FOR CONTROLLING THE DIRECTION
void my_direction(){                                                          

  if (k2==1){
    Serial.println("Enter the direction(clockwise=0, counterclockwise=1)");
    j1=1;
  }

  while(! Serial.available());
  
  if (Serial.available() && j1==1){

    direction1 = Serial.parseInt();
    if (direction1 == 0 || direction1 == 1){

      if(direction1 == 0){
        dir=false;
        Serial.println("clockwise");
      }

      else{
        dir=true;
        Serial.println("counter-clockwise");
      }
      
    }
     else{
        Serial.println("invalid entry");
        delay(200);
        my_direction();
      }
      
   digitalWrite(motor_1_in_1, dir);
   digitalWrite(motor_1_in_2,!dir);
      
   k2=0;
   j1=0;
   
   my_menu();
          
  }
}


//FUNCTION FOR CONTROLLING THE SPEED
void my_speed(){                                       

  if (k3==1){
    Serial.println("Enter the speed(between 0-255)");
    j3=1;
  }  

  while (! Serial.available());
  
  if (Serial.available() && j3==1){  
    speed1 = Serial.parseInt();
    if (speed1 >= 0 && speed1 <= 255){
      analogWrite(motor_1_enable, speed1);
      Serial.print("speed is ");
      Serial.println(speed1);
      j3=0;
    }
    
    else{
      Serial.println("invalid entry");
      delay(200);
      my_speed();
    
    }
    k3=0;
    my_menu();      

  }
}


//FUNCTION FOR THE BRAKING OF THE MOTOR
void brake(){                                  
  if(k4==1){
    Serial.println("press 0 to free run");
    Serial.println("press 1 to brake");
   j6=1;
  }
 
    while (! Serial.available());
    if (Serial.available() && j6==1){  
      brake1 = Serial.parseInt();
      if (brake1==0){
        digitalWrite(motor_1_in_1, false);
        digitalWrite(motor_1_in_2, false);
        speed1=0;
        direction1=2;
        Serial.println("        ");
        Serial.println("motor free running");
        Serial.println("=======================================================");
        Serial.println("      ");
      }
      else if(brake1==1){
        digitalWrite(motor_1_in_1, true);
        digitalWrite(motor_1_in_2, true);
        speed1=0;
        direction1=2;
        Serial.println("        ");
        Serial.println("motor braking");
        Serial.println("=======================================================");
        Serial.println("      ");
      }
      else{
         Serial.println("invalid Entry");
         brake();
      }
 
       k4=0;
       j6=0;
       speed1=0;
       direction1=2;
       my_menu(); 
     
    }

  }


